﻿using System;
using System.ServiceModel;
using System.Threading;
using Contract;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            ServiceHost host = new ServiceHost(typeof(Worker));
            host.AddServiceEndpoint(typeof(IWorker), new NetNamedPipeBinding(), "net.pipe://localhost/Worker");
            host.Open();

            Console.ReadLine();
        }
    }

    [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single, ConcurrencyMode = ConcurrencyMode.Reentrant)]
    public class Worker : IWorker
    {
        private ISupervisor supervisor;

        public Worker()
        {
            EndpointAddress endpointAddress = new EndpointAddress("net.pipe://localhost/Supervisor");
            NetNamedPipeBinding binding = new NetNamedPipeBinding();
            supervisor = ChannelFactory<ISupervisor>.CreateChannel(binding, endpointAddress);
        }

        public void RunTask(int timeInSeconds)
        {
            //Task.Factory.StartNew(() =>
            //{
            int milliseconds = timeInSeconds * 1000;
            int sleepTime = milliseconds / 100;
            for (int i = 1; i <= 100; i++)
            {
                Thread.Sleep(sleepTime);
                supervisor.Report(i);
                Console.WriteLine("progress {0}%     thread id: {1}", i, Thread.CurrentThread.ManagedThreadId);
            }
            //});
        }

        public void Print()
        {
            Console.WriteLine("print something     thread id: {0}", Thread.CurrentThread.ManagedThreadId);
        }
    }
}
